#include "test_file_accessor.h"
#include "test_file_opener.h"

#include <stdlib.h>

/* Support for providing access to files. */

TestFileOpener::TestFileOpener(Pages *pages, offset_t file_size)
: OpenerResource(pages), _file_size(file_size)
{
}

/* Return a file identifier for the given 'path'. */

fileid_t TestFileOpener::get_fileid(const char *path)
{
    /* NOTE: Just convert the path to a number. */

    return atol(path);
}

/* Return a new accessor for 'fileid'. */

Accessor *TestFileOpener::make_accessor(fileid_t fileid)
{
    return new TestFileAccessor(fileid, _file_size);
}

// vim: tabstop=4 expandtab shiftwidth=4
