#pragma once

#include <systypes/base.h>

#include <mutex>

#include "memory.h"
#include "memory_utils.h"



/* A memory pool abstraction. */

class MemoryIncremental : public Memory
{
protected:
    std::mutex _lock;

    unsigned int _limit;
    length_t _region_size;
    bool _limited;

    Region *allocate(length_t size);

public:
    explicit MemoryIncremental(unsigned int limit, length_t region_size=PAGE_SIZE);

    explicit MemoryIncremental();

    virtual Region *region(length_t size);

    virtual Region *region();

    virtual length_t region_size()
    { return _region_size; }

    virtual void release(Region *region);
};

// vim: tabstop=4 expandtab shiftwidth=4
